package org.squarebrackets;

/**
 * Interface for array modification.
 *
 * @param <E> element type.
 * @param <T> return type.
 */
public interface ArrayAction<E, T> {

    /**
     * Executes this action and returns a result object, or {@code null} at discretion of the action.
     *
     * @param context provides access to array characteristics.
     * @return result of the action.
     */
    T run(ArrayContext<E> context);
}
